import java.io.IOException;

import org.apache.hadoop.io.DoubleWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

/**
 * Reduce class
 * @author SergeiL
 */
public class ClaraCostReducer extends Reducer<Text, DoubleWritable, Text, DoubleWritable>
{
	@Override
	protected void reduce(Text key, Iterable<DoubleWritable> values, Context context) throws IOException, InterruptedException
	{		
		double result = 0;
		
		for (DoubleWritable cost : values)
		{
			result += cost.get();
		}
		
		context.write(key, new DoubleWritable(result));
	}
}