import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Hashtable;

import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

/**
 * Reduce class
 * @author SergeiL
 */
public class PkNnReducer extends Reducer<LongWritable, Text, LongWritable, Text>
{
	@Override
	protected void reduce(LongWritable key, Iterable<Text> values, Context context) throws IOException, InterruptedException
	{
		DataField field;
		String[] objArr;
		ArrayList<DataField> fields = new ArrayList<DataField>();
		Hashtable<Long, Integer> groups = new Hashtable<Long, Integer>();
		DataField f;
		long maxGroup = Long.MIN_VALUE;
		int maxGroupCount = Integer.MIN_VALUE;
		int neigh = context.getConfiguration().getInt("NUM_OF_NEIGHBOURS", 0);

		for (Text value : values)
		{
			objArr = value.toString().split(";");
			field = new DataField(key.get(), Double.parseDouble(objArr[0]), Long.parseLong(objArr[1]));
			fields.add(field);
		}

		Collections.sort(fields);

		for (int i = 0; i < neigh; i++)
		{
			f = fields.get(i);
			if(groups.containsKey(f.getGroup())) groups.put(f.getGroup(), groups.get(f.getGroup()) + 1);
			else groups.put(f.getGroup(), 1);
			if(groups.get(f.getGroup()) > maxGroupCount) 
			{
				maxGroupCount = groups.get(f.getGroup());
				maxGroup = f.getGroup();
			}
		}
		
		context.write(key, new Text(String.valueOf(maxGroup)));
	}
}