import java.io.Serializable;

public class DataField implements Comparable<DataField>, Serializable
{
	private static final long serialVersionUID = 1L;
	private long mId;
	private long mXCoordinate;
	private long mYCoordinate;
	private long mGroup;
	private double mDistance;

	/**
	 * Constructor
	 * @param id - id
	 * @param x - x coordinate
	 * @param y - y coordinate
	 */
	public DataField(long id, long x, long y)
	{
		super();
		mId = id;
		mXCoordinate = x;
		mYCoordinate = y;
		mGroup = -1;
		mDistance = 0;
	}

	/**
	 * Constructor
	 * @param id - id
	 * @param x - x coordinate
	 * @param y - y coordinate
	 * @param group - group
	 */
	public DataField(long id, long x, long y, long group)
	{
		mId = id;
		mXCoordinate = x;
		mYCoordinate = y;
		mGroup = group;
		mDistance = 0;
	}

	/**
	 * Constructor
	 * @param id - id
	 * @param distance - distance
	 * @param group - group
	 */
	public DataField(long id, double distance, long group)
	{
		mId = id;
		mGroup = group;
		mDistance = distance;
	}

	/**
	 * Compare function
	 */
	public int compareTo(DataField compareObject)
	{
		if (mDistance < compareObject.getDistance()) return -1;
		else if (mDistance == compareObject.getDistance()) return 0;
		else return 1;
	}

	/**
	 * Get id
	 * @return long
	 */
	public long getId()
	{
		return mId;
	}

	/**
	 * Set id
	 * @param value - long
	 */
	public void setId(long value)
	{
		mId = value;
	}

	/**
	 * Get x coordinate
	 * @return long
	 */
	public long getX()
	{
		return mXCoordinate;
	}

	/**
	 * Set x coordinate
	 * @param value - long
	 */
	public void setX(long value)
	{
		mXCoordinate = value;
	}

	/**
	 * Get y coordinate
	 * @return long
	 */
	public long getY()
	{
		return mYCoordinate;
	}

	/**
	 * Set y coordinate
	 * @param value - long
	 */
	public void setY(long value)
	{
		mYCoordinate = value;
	}

	/**
	 * Get group
	 * @return long
	 */
	public long getGroup()
	{
		return mGroup;
	}

	/**
	 * Set group
	 * @param value - long
	 */
	public void setGroup(long value)
	{
		mGroup = value;
	}

	/**
	 * Get distance
	 * @return double
	 */
	public double getDistance()
	{
		return mDistance;
	}

	/**
	 * Set distance
	 * @param value - double
	 */
	public void setDistance(double value)
	{
		mDistance = value;
	}
}